function calculateFinal() {

    $("input[name='incomeDeviceFinalTotal']").change(function () {
        calIncomeFinalTotal();
    });
    $("input[name='incomeEngineerFinalTotal']").change(function () {
        calIncomeFinalTotal();
    });
    $("input[name='incomeServiceFinalTotal']").change(function () {
        calIncomeFinalTotal();
    });

    /**
     * 收入决算总额(不含税)，有一项没填就置空
     */
    function calIncomeFinalTotal() {
        var incomeDeviceFinalTotal = $("input[name='incomeDeviceFinalTotal']").val();
        var incomeEngineerFinalTotal = $("input[name='incomeEngineerFinalTotal']").val();
        var incomeServiceFinalTotal = $("input[name='incomeServiceFinalTotal']").val();

        var incomeFinalTotal = $("input[name='incomeFinalTotal']");

        if(incomeDeviceFinalTotal && incomeEngineerFinalTotal && incomeServiceFinalTotal){
            incomeFinalTotal.val(parseFloat(incomeDeviceFinalTotal)+parseFloat(incomeEngineerFinalTotal)+parseFloat(incomeServiceFinalTotal));
        }else {
            incomeFinalTotal.val("");
        }
    }

    $("input[name='costPurchaseDeviceFinalTotal']").change(function () {
        calCostFinalTotal();
    });
    $("input[name='costPurchaseBuildFinalTotal']").change(function () {
        calCostFinalTotal();
    });
    $("input[name='costPurchaseServiceFinalTotal']").change(function () {
        calCostFinalTotal();
    });
    $("input[name='costPurchaseOtherFinalTotal']").change(function () {
        calCostFinalTotal();
    });
    $("input[name='costProjectManageFinalTotal']").change(function () {
        calCostFinalTotal();
    });
    $("input[name='costOtherFinalTotal']").change(function () {
        calCostFinalTotal();
    });


    $("input[name='costExpropriationFinalTotal']").change(function () {
        calManageFinalTotal();
        calGrossProfitFinalTotal();
    });
    $("input[name='costCompanyManageFinalTotal']").change(function () {
        calManageFinalTotal();
        calContributionMarginFinalTotal()
    });
    $("input[name='costIncomeTaxFinalTotal']").change(function () {
        calManageFinalTotal();
        calNetMarginProfitMargin();
    });


    $("input[name='saleIncomeCash']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='taxReturn']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='earnestMoneyIncome']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='purchaseCost']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='taxCost']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='earnestMoneyCost']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='netCashFlow']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='cashInflowFromInvestingActivities']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='cashOutflowFromInvestingActivities']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='netCashFromInvestingActivities']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='financingCapitalInflow']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='financingCapitalOutflow']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='financingCapitalCashflow']").change(function () {
        calCashFluxFinalTotal();
    });
    $("input[name='netIncreaseMonetaryFunds']").change(function () {
        calCashFluxFinalTotal();
    });

}

/**
 * 成本决算总额(不含税)，有一项没填就置空
 */
function calCostFinalTotal() {
    var costPurchaseDeviceFinalTotal = $("input[name='costPurchaseDeviceFinalTotal']").val();
    var costPurchaseBuildFinalTotal = $("input[name='costPurchaseBuildFinalTotal']").val();
    var costPurchaseServiceFinalTotal = $("input[name='costPurchaseServiceFinalTotal']").val();
    var costPurchaseOtherFinalTotal = $("input[name='costPurchaseOtherFinalTotal']").val();
    var costProjectManageFinalTotal = $("input[name='costProjectManageFinalTotal']").val();
    var costOtherFinalTotal = $("input[name='costOtherFinalTotal']").val();

    var costFinalTotal = $("input[name='costFinalTotal']");

    if(costPurchaseDeviceFinalTotal && costPurchaseBuildFinalTotal && costPurchaseServiceFinalTotal &&
        costPurchaseOtherFinalTotal && costProjectManageFinalTotal && costOtherFinalTotal){
        costFinalTotal.val(parseFloat(costPurchaseDeviceFinalTotal)+parseFloat(costPurchaseBuildFinalTotal)+parseFloat(costPurchaseServiceFinalTotal)+
            parseFloat(costPurchaseOtherFinalTotal)+parseFloat(costProjectManageFinalTotal)+parseFloat(costOtherFinalTotal));
    }else {
        costFinalTotal.val("");
    }
}


/**
 * 管理成本总额(不含税)，有一项没填就置空
 */
function calManageFinalTotal() {
    var costExpropriationFinalTotal = $("input[name='costExpropriationFinalTotal']").val();
    var costCompanyManageFinalTotal = $("input[name='costCompanyManageFinalTotal']").val();
    var costIncomeTaxFinalTotal = $("input[name='costIncomeTaxFinalTotal']").val();

    var manageFinalTotal = $("input[name='manageFinalTotal']");

    if(costExpropriationFinalTotal && costCompanyManageFinalTotal && costIncomeTaxFinalTotal){
        manageFinalTotal.val(parseFloat(costExpropriationFinalTotal)+parseFloat(costCompanyManageFinalTotal)+parseFloat(costIncomeTaxFinalTotal));
    }else {
        manageFinalTotal.val("");
    }
}

/**
 * 现金流量表总额(不含税)，有一项没填就置空
 */
function calCashFluxFinalTotal() {
    var saleIncomeCash = $("input[name='saleIncomeCash']").val();
    var taxReturn = $("input[name='taxReturn']").val();
    var earnestMoneyIncome = $("input[name='earnestMoneyIncome']").val();
    var purchaseCost = $("input[name='purchaseCost']").val();
    var taxCost = $("input[name='taxCost']").val();
    var earnestMoneyCost = $("input[name='earnestMoneyCost']").val();
    var netCashFlow = $("input[name='netCashFlow']").val();
    var cashInflowFromInvestingActivities = $("input[name='cashInflowFromInvestingActivities']").val();
    var cashOutflowFromInvestingActivities = $("input[name='cashOutflowFromInvestingActivities']").val();
    var netCashFromInvestingActivities = $("input[name='netCashFromInvestingActivities']").val();
    var financingCapitalInflow = $("input[name='financingCapitalInflow']").val();
    var financingCapitalOutflow = $("input[name='financingCapitalOutflow']").val();
    var financingCapitalCashflow = $("input[name='financingCapitalCashflow']").val();
    var netIncreaseMonetaryFunds = $("input[name='netIncreaseMonetaryFunds']").val();

    var cashFluxFinalTotal = $("input[name='cashFluxFinalTotal']");

    if(saleIncomeCash && taxReturn && earnestMoneyIncome &&
        purchaseCost && taxCost && earnestMoneyCost&&
        netCashFlow && cashInflowFromInvestingActivities && cashOutflowFromInvestingActivities &&
        netCashFromInvestingActivities && financingCapitalInflow && financingCapitalOutflow
        && financingCapitalCashflow && netIncreaseMonetaryFunds){
        cashFluxFinalTotal.val(parseFloat(saleIncomeCash)+parseFloat(taxReturn)+parseFloat(earnestMoneyIncome)+
            parseFloat(purchaseCost)+parseFloat(taxCost)+parseFloat(earnestMoneyCost)+
            parseFloat(netCashFlow)+parseFloat(cashInflowFromInvestingActivities)+parseFloat(cashOutflowFromInvestingActivities)+
            parseFloat(netCashFromInvestingActivities)+parseFloat(financingCapitalInflow)+parseFloat(financingCapitalOutflow)+
            parseFloat(financingCapitalCashflow)+parseFloat(netIncreaseMonetaryFunds));
    }else {
        cashFluxFinalTotal.val("");
    }
}

/**
 * 项目毛利决算总额
 */
function calGrossProfitFinalTotal() {
    var incomeFinalTotal = $("input[name='incomeFinalTotal']").val();
    var costFinalTotal = $("input[name='costFinalTotal']").val();
    var costExpropriationFinalTotal = $("input[name='costExpropriationFinalTotal']").val();

    var grossProfitFinalTotal = $("input[name='grossProfitFinalTotal']");

    if(incomeFinalTotal && costFinalTotal && costExpropriationFinalTotal){
        grossProfitFinalTotal.val(parseFloat(incomeFinalTotal)-parseFloat(costFinalTotal)-parseFloat(costExpropriationFinalTotal));
    }else {
        grossProfitFinalTotal.val("");
    }
}

/**
 * 项目贡献利润决算总额
 */
function calContributionMarginFinalTotal() {
    var grossProfitFinalTotal = $("input[name='grossProfitFinalTotal']").val();
    var costCompanyManageFinalTotal = $("input[name='costCompanyManageFinalTotal']").val();

    var contributionMarginFinalTotal = $("input[name='contributionMarginFinalTotal']");

    if(grossProfitFinalTotal && costCompanyManageFinalTotal ){
        contributionMarginFinalTotal.val(parseFloat(grossProfitFinalTotal)-parseFloat(costCompanyManageFinalTotal));
    }else {
        contributionMarginFinalTotal.val("");
    }
}

/**
 * 项目净利润决算总额
 */
function calNetMarginProfitMargin() {
    var contributionMarginFinalTotal = $("input[name='contributionMarginFinalTotal']").val();
    var costIncomeTaxFinalTotal = $("input[name='costIncomeTaxFinalTotal']").val();


    var netMarginFinalTotal = $("input[name='netMarginFinalTotal']");

    if(contributionMarginFinalTotal && costIncomeTaxFinalTotal ){
        netMarginFinalTotal.val(parseFloat(contributionMarginFinalTotal)-parseFloat(costIncomeTaxFinalTotal));
    }else {
        netMarginFinalTotal.val("");
    }
}






